<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  </script>

</head>

<body>
  <div class="container">
    <h2 style="text-align: center;">Personal Data Submit Form</h2>

    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-first-name">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="inp-first-name" name="firstname" placeholder="Your first name ..."
            class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="inp-last-name">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="inp-last-name" name="lastname" placeholder="Your last name.." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="age">Age</label>
        </div>
        <div class="col-sm-9">
          <input type="number" id="inp-age" name="age" placeholder="Your age ..." class="form-control">
        </div>
      </div>
      <div class="row">
        <div class="col-sm-12" style="text-align: right;">
          <button id="btn-submit-data" class="btn btn-info">Submit Data</button>
        </div>
      </div>
    </div>
    <!-- HTML Log -->
    <hr>
    <div style="text-align: right;">
      <button id="btn-clear-log" class="btn btn-info"> Clear HTML Log </button>
    </div>
    <p id="p-html-log"></p>
  </div>
</body>

</html>
<script>
  $(document).ready(function() {
    /*** REGION 1 - Global variables ***/
    // Khởi tạo biến lưu trữ dữ liệu
    var vPerson = {};

    /*** REGION 2 - Event handlers ***/
    // Xử lý sự kiện khi nhấn nút "Submit Data"
    $("#btn-submit-data").click(function() {
      submitData();
    });

    // Xử lý sự kiện khi nhấn nút "Clear HTML Log"
    $("#btn-clear-log").click(function() {
      clearHTMLLog();
    });

    /*** REGION 3 - Event handler functions ***/
    // Hàm xử lý khi nhấn nút "Submit Data"
    function submitData() {
      // Bước 1: Thu thập dữ liệu từ form và lưu vào object formData
      var firstName = $("#inp-first-name").val();
      var lastName = $("#inp-last-name").val();
      var age = $("#inp-age").val();

      vPerson = {
        firstName: firstName,
        lastName: lastName,
        age: age
      };

      // Bước 2: Validate dữ liệu
      if (validateData()) {
        // Bước 3: Nối dữ liệu hợp lệ vào vùng log
        appendToHTMLLog(vPerson);
      }
    }

    // Hàm xử lý khi nhấn nút "Clear HTML Log"
    function clearHTMLLog() {
      $("#p-html-log").html("");
    }

    /*** REGION 4 - Common functions ***/
    // Hàm validate dữ liệu
    function validateData() {
      // Kiểm tra trường bắt buộc
      if (!vPerson.firstName || !vPerson.lastName || !vPerson.age) {
        console.log("Dữ liệu không hợp lệ");
        return false;
      }

      // Kiểm tra tuổi
      var ageValue = parseInt(vPerson.age);
      if (isNaN(ageValue) || ageValue <= 0 || ageValue >= 200) {
        console.log("Dữ liệu không hợp lệ");
        return false;
      }

      return true;
    }

    // Hàm nối dữ liệu vào vùng log
    function appendToHTMLLog(data) {
      var logText = "> Age: " + data.age + "<br>" +
        "> First Name: " + data.firstName + "<br>" +
        "> Last Name: " + data.lastName + "<br>" +
        ">";
      $("#p-html-log").append(logText + "<br>");
    }
  });
</script>